package com.smcic.api.tags.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.smcic.api.tags.dto.UserTagsDTO;
import com.smcic.api.tags.entity.UserTags;
import com.smcic.api.tags.job.UserTagsConsumer;
import com.smcic.api.tags.mapper.UserTagsMapper;
import com.smcic.api.tags.service.IUserTagsService;
import com.smcic.api.tags.service.TagsQueue;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.util.concurrent.ThreadPoolExecutor;

@Service
@Slf4j
public class UserTagsService extends ServiceImpl<UserTagsMapper, UserTags> implements IUserTagsService {

    @Resource
    private UserTagsConsumer userTagsConsumer;

    @Resource
    private ThreadPoolExecutor threadPoolExecutor;

    @PostConstruct
    public void init(){
        threadPoolExecutor.execute(() -> {
            userTagsConsumer.run();
        });
    }
    public void insert(UserTagsDTO userTags){
        log.info("insert userTags:{}",userTags);
        userTags.setCreateTime(LocalDateTime.now());
        TagsQueue.getInstance().getUserTags().add(userTags);
    }
}
